<%@language = "JavaScript" %>
<%
/*
 * GoLive
 *
 * ADOBE SYSTEMS INCORPORATED
 * Copyright 2000-2002 Adobe Systems Incorporated. All Rights Reserved.
 * 
 * NOTICE:  Notwithstanding the terms of the Adobe GoLive End User 
 * License Agreement, Adobe permits you to reproduce and distribute this 
 * file only as an integrated part of a web site created with Adobe 
 * GoLive software and only for the purpose of enabling your client to 
 * display their web site. All other terms of the Adobe license 
 * agreement remain in effect.
 */

var RuntimeDebug = 0;
var title = '', bgcolor = 'fff';
var tloc = '', template = '', tlm = '', dataXML = '';
var acbytes = '', acdata = '', acreq = '', acresp = '',
	acserv = '';
var errnum = '', errdesc = '';

function xmlencode(s) {
	s = String(s);
	var s2 = '';
	var k = "\"'&<>";
	for (var i = 0; i < s.length; ++i) {
		var ix = k.indexOf(s.charAt(i));
		if (ix >= 0)
			s2 += '&#' + s.charCodeAt(i) + ';';
		else
			s2 += s.charAt(i);
	}
	return s2;
}

function acsubst() {
	/*
	 * Trip through the arguments to
	 * (1) Capture the template URL
	 * (2) Capture any special flags
	 * (3) Construct the list of variable bindings:
	 *	<data>
	 *		<varname>value</varname>
	 *	</data>
	 */
	dataXML = "<data>\r\n";
	template = '';
	for (var e = new Enumerator(Request.QueryString);
		!e.atEnd(); e.moveNext())
	{
		var k = String(e.item());
		var v = String(Request.QueryString.Item(k));
		if (k=='_t')
			template = v;
		else if (k=='_d')
			RuntimeDebug = v;
		else {
			k = xmlencode(k);
			v = xmlencode(v);
			dataXML += "\t<" + k + ">";
			dataXML += v;
			dataXML += "</" + k + ">\r\n";
		}
	}
	dataXML += "</data>\r\n";

	tloc = template;
	if (template.indexOf('/')==0) {
		template = 'file:///'
			+ String(Server.MapPath(template)).replace(/\\/g, '/');
	}

	tlm = "<commands>\r\n"
		+ "\t<loadContent source='vdata' out='data' />\r\n"
		+ "\t<loadContent source='" + template + "'/>\r\n"
		+ "\t<applyVariables/>\r\n"
		+ "</commands>\r\n";

	try {
		// Create the server object
		acserv = Server.CreateObject("AlterCastCOM.ACServer");

		// Create the request
		acreq = Server.CreateObject("AlterCastCOM.ACRequest");
		// acreq.setResultLocation('c:/temp/results.txt');

		// Add the data xml we created from the query args
		if (acreq) {
			acreq.addString("vdata", dataXML);
			acreq.SetCommands(tlm);
		}

		// Execute the request
		acresp = !acreq ? null : acserv.Execute(acreq);

		// Get the response data
		acdata = !acresp ? null : acresp.getData();

		// Get the response record for the first data
		acbytes = !acdata ? null : acdata.Item(1);
	}
	catch (e) {
		errnum = xmlencode(e.number);
		errdesc = xmlencode(e.description);
		if (!RuntimeDebug) {
			Response.Status = "500 Internal server error";
			Response.ContentType = "text/xml";
			var msg = "<ERROR Number='" + errnum
				+ "' Description='" + errdesc
				+ "'/>\r\n";
			Response.Write(msg);
			Response.End();
			return;
		}
	}

	if (!acbytes) {
		title = 'Altercast request failed.';
		bgcolor = 'fcc';
	}
	else if (RuntimeDebug) {
		title = 'Altercast request succeeded.';
	}
	else {
		// Write the binary results
		Response.ContentType = "image/gif";
		Response.BinaryWrite(acbytes.getData());
		Response.End();
	}
}

/*
 * Dispatch.
 */
Response.Expires = 0;	/* remember-me-not. */
acsubst();

%>
<html><head>
<title><%=title%></title>
<style type='text/css'><!--
	body {
		background-color: #<%=bgcolor%>;
	}
  --></style>
</head><body>
<h2><%=title%></h2>
<h3>tlm</h3>
<p><pre>
<%=Server.HTMLEncode(tlm)%>
</pre>
<h3>vdata</h3>
<p><pre>
<%=Server.HTMLEncode(dataXML)%>
</pre>
<h3>tloc</h3>
<p><code><%=Server.HTMLEncode(tloc)%></code>
<h3>Altercast items</h3>
<p>
<b>acreq</b> <code><%=acreq ? 'ok' : 'null'%></code>,
<b>acresp</b> <code><%=acresp ? 'ok' : 'null'%></code>,
<b>acdata</b> <code><%=acdata ? 'ok' : 'null'%></code>,
<b>acbytes</b> <code><%=acbytes ? 'ok' : 'null'%></code>
<h3>Altercast error status</h3>
<p>
<b>errnum</b> <code><%=errnum%></code>
<p>
<b>errdesc</b> <code><%=errdesc%></code>
</body></html>
